#ifndef _LIBDENOISING_H_
#define _LIBDENOISING_H_

#include "libraryBasic.h"


#define MNPCA 2
#define VERBOSE 0



namespace libIIPStable 
{
	

    
    void denoising_dct_threshold(float *fpI, float *fpA, float *fpO, int iWidth, int iHeight, int iWin, float fRMult, float fSigma, int flagOverlapping, int flagWiener, int iSampling, int flagFlat, float valueFlat);
	
	
	void nlmeans_ipol(int iDWin,			// Half size of comparison window  
					  int iDBloc,		// Half size of research window
					  float fSigma,		// Noise parameter
					  float fFiltPar,	// Filtering parameter
					  float **fpI,		// Input
					  float **fpO,		// Output
					  int iChannels, int iWidth,int iHeight);
	

    void nlmeans(int iDWin,			// Half size of comparison window  
				 int iDBloc,		// Half size of research window
				 int ifOverlap,		// IF not zero THEN block synthesized and average at intersections
				 int ifThreshold,	// IF not zero THEN threshold function ELSE  exponential function
				 float * fpKernel,  int iKerWidth, // IF fpKernel != NULL THEN weighted window distance
				 int iSampling,		// Sampling 
                 int iK,            // use first kNN
				 float fSigma,		// Noise parameter
				 float fFiltPar,	// Filtering parameter
				 float **fpI,		// Input
				 float **fpA,		// Auxiliary input for distance computation
				 float **fpO,		// Output
				 int iChannels, int iWidth,int iHeight);
	
    
	
//	void wiener_filtering(float **fpI, float **fpA, float **fpO, float *fpSPC,
//						  char * option, int ifCopying,  int ifAOverlap, 
//						  int iDWin, int iDBloc,
//						  float fSigma, int idisttype,
//						  int iSampling, int ifK, 
//						  float fMult, float fRMult, int iChannels, int iWidth, int iHeight);
//	
   
	
    void lmmse_filtering(float **fpI, float **fpA, float **fpO,
						 char *algoType,
						 int ifCopying,	
						 int iWinC, int iWin, int iBloc,
						 float fSigma, int idisttype,
						 int iSampling, int ifK, int ifuseFlat, float useFlatPar, int ifSecondaryFilt,
						 float fMult, float fRMult, int iChannels, int iWidth, int iHeight);

    
    void lmmse_filtering_weighted_window(float **fpI, float **fpA, float **fpO,
                                         char *algoType,
                                         int ifCopying,	
                                         int iWin, int jWin, float *kernel,
                                         int iBloc,
                                         float fSigma, int idisttype,
                                         int iSampling, int ifK, int ifuseFlat, float useFlatPar, int ifSecondaryFilt,
                                         float fMult, float fRMult, int iChannels, int iWidth, int iHeight);
    
	

    void nlmeans_single_frame(int iIndex,	// iIndex of denoised frame
                              int iDtemp,	// Half size of temporal window
                              int iDWin,		// Half size of comparison window  
                              int iDBloc,		// Half size of research window
                              float fSigma,		// Noise parameter
                              float fFiltPar,	// Filtering parameter
                              float ***fpI,		// Input
                              float **fpO,		// Output
                              float *fpMask,	// Mask
                              int iFrames, int iChannels, int iWidth,int iHeight);
    
}


#endif
